//-----------------------------------------------------------------------------
// blend.c : uh
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#include <windows.h>

#include "filter.h"
#include "blend.h"

// gpW
static const u64_i16 mc_4k = { 4096, 4096, 4096, 4096 };
static const u64_i32 mc_2k = { 2047, 2047 };
static const u128i_i32 xc_4k = { 4096, 4096, 4096, 4096 };
static const u128i_i32 xc_2k = { 2047, 2047, 2047, 2047 };

//̗ʂɂăuh
// mv0o mv1͗pȂ
NOA void blend_image(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                     const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    int y,cr,cb,c0,c1;
    
    for(i=0; i<w; ++i){
        c0 = *mv0++;
        c1 = 4096 - c0;
        
        y  = c0 * dst->y  + c1 * src->y  + 2047;
        cb = c0 * dst->cb + c1 * src->cb + 2047;
        cr = c0 * dst->cr + c1 * src->cr + 2047;
        
        dst->y  = (short)(y  >> 12);
        dst->cb = (short)(cb >> 12);
        dst->cr = (short)(cr >> 12);
        
        dst++;
        src++;
    }
}

//̗ʂɂăuh
// 2̌oʂ̂ق𗘗p
NOA void blend_image_min(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    int y,cr,cb,c0,c1;
    
    for(i=0; i<w; ++i){
        c0 = *mv0++;
        c1 = *mv1++;
        c0 = c0 < c1 ? c0 : c1;
        c1 = 4096 - c0;
        
        y  = c0 * dst->y  + c1 * src->y  + 2047;
        cb = c0 * dst->cb + c1 * src->cb + 2047;
        cr = c0 * dst->cr + c1 * src->cr + 2047;
        
        dst->y  = (short)(y  >> 12);
        dst->cb = (short)(cb >> 12);
        dst->cr = (short)(cr >> 12);
        
        dst++;
        src++;
    }
}

//̗ʂɂăuh
// 2̌oʂ̂傫ق𗘗p
NOA void blend_image_max(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    int y,cr,cb,c0,c1;
    
    for(i=0; i<w; ++i){
        c0 = *mv0++;
        c1 = *mv1++;
        c0 = c0 > c1 ? c0 : c1;
        c1 = 4096 - c0;
        
        y  = c0 * dst->y  + c1 * src->y  + 2047;
        cb = c0 * dst->cb + c1 * src->cb + 2047;
        cr = c0 * dst->cr + c1 * src->cr + 2047;
        
        dst->y  = (short)(y  >> 12);
        dst->cb = (short)(cb >> 12);
        dst->cr = (short)(cr >> 12);
        
        dst++;
        src++;
    }
}


//̗ʂɂăuh SSE
// mv0o mv1͗pȂ
NOA void blend_image_sse(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m64 mm0,mm1,md0,ms0,mc0,mc1,mc2;
    
    mc0 = *(p_m64c)mv0;
    mv0 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        mc1 = _mm_subs_pu16(mc_4k.m, mc0); //mc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        //load:0
        md0 = *(p_m64r)dst; //md0 (Yd1, Crd0, Cbd0, Yd0)
        ms0 = *(p_m64c)src; //ms0 (Ys1, Crs0, Cbs0, Ys0)
        
        mc2 = _mm_unpackhi_pi16(mc1, mc0); //mc2 (c3,4k-c3,c2,4k-c2)
        mc1 = _mm_unpacklo_pi16(mc1, mc0); //mc1 (c1,4k-c1,c0,4k-c0)
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Yd1,   Ys1, Crd0, Crs0)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Cbd0, Cbs0,  Yd0,  Ys0)
        
        mc0 = _mm_unpacklo_pi32(mc1, mc1); //mc0 (c0,4k-c0,c0,4k-c0)
        
        //load:1
        md0 = *((p_m64r)dst + 1); //md0 (Cbd2, Yd2, Crd1, Cbd1)
        ms0 = *((p_m64c)src + 1); //ms0 (Cbs2, Ys2, Crs1, Cbs1)
        
        mm0 = _mm_madd_pi16(mm0, mc1); //mm0 (Yd1*c1 + Ys1*(4k-c1), Crd0*c0 + Crs1*(4k-c0))
        mm1 = _mm_madd_pi16(mm1, mc0); //mm1 (Cbd0*c0 + Cbs0*(4k-c0), Yd0*c0 + Ys0*(4k-c0))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:0
        *(p_m64r)dst = _mm_packs_pi32(mm1, mm0);
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Cbd2, Cbs2, Yd2, Ys2)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Crd1, Crs1, Cbd1, Cbs1)
        
        mc0 = _mm_unpacklo_pi32(mc2, mc2); //mc0 (c2,4k-c2,c2,4k-c2)
        mc1 = _mm_unpackhi_pi32(mc1, mc1); //mc1 (c1,4k-c1,c1,4k-c1)
        
        //load:2
        md0 = *((p_m64r)dst + 2); //md0 (Crd3, Cbd3, Yd3, Crd2)
        ms0 = *((p_m64c)src + 2); //ms0 (Crs3, Cbs3, Ys3, Crs2)
        
        mm0 = _mm_madd_pi16(mm0, mc0); //mm0 (Cbd2*c2 + Cbs2*(4k-c2), Yd2*c2 + Ys2*(4k-c2))
        mm1 = _mm_madd_pi16(mm1, mc1); //mm1 (Crd1*c1 + Crs1*(4k-c1), Cbd1*c1 + Cbs1*(4k-c1))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:1
        *((p_m64r)dst + 1) = _mm_packs_pi32(mm1, mm0);
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Crd3, Crs3, Cbd3, Cbs3)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Yd3, Ys3, Crd2, Crs2)
        
        mc1 = _mm_unpackhi_pi32(mc2, mc2); //mc1 (c3,4k-c3,c3,4k-c3)

        //ǂ
        mc0 = *(p_m64c)mv0;
        
        mm0 = _mm_madd_pi16(mm0, mc1); //mm0 (Crd3*c3 + Crs3*(4k-c3), Cbd3*c3 + Cbs3*(4k-c3))
        mm1 = _mm_madd_pi16(mm1, mc2); //mm1 (Yd3*c3 + Ys3*(4k-c3), Crd2*c2 + Crs2*(4k-c2))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:2
        *((p_m64r)dst + 2) = _mm_packs_pi32(mm1, mm0);
        
        mv0 += 4;
        dst += 4;
        src += 4;
    }
}

//̗ʂɂăuh SSE
// 2̌oʂ̂ق𗘗p
NOA void blend_image_min_sse(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                             const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m64 mm0,mm1,md0,ms0,mc0,mc1,mc2;
    
    mc0 = _mm_min_pi16(*(p_m64c)mv0, *(p_m64c)mv1);
    mv0 += 4;
    mv1 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        mc1 = _mm_subs_pu16(mc_4k.m, mc0); //mc1 (4k-c3,4k-c2,4k-c1,4k-c0)

        //load:0
        md0 = *(p_m64r)dst; //md0 (Yd1, Crd0, Cbd0, Yd0)
        ms0 = *(p_m64c)src; //ms0 (Ys1, Crs0, Cbs0, Ys0)
        
        mc2 = _mm_unpackhi_pi16(mc1, mc0); //mc2 (c3,4k-c3,c2,4k-c2)
        mc1 = _mm_unpacklo_pi16(mc1, mc0); //mc1 (c1,4k-c1,c0,4k-c0)
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Yd1,   Ys1, Crd0, Crs0)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Cbd0, Cbs0,  Yd0,  Ys0)
        
        mc0 = _mm_unpacklo_pi32(mc1, mc1); //mc0 (c0,4k-c0,c0,4k-c0)
        
        //load:1
        md0 = *((p_m64r)dst + 1); //md0 (Cbd2, Yd2, Crd1, Cbd1)
        ms0 = *((p_m64c)src + 1); //ms0 (Cbs2, Ys2, Crs1, Cbs1)
        
        mm0 = _mm_madd_pi16(mm0, mc1); //mm0 (Yd1*c1 + Ys1*(4k-c1), Crd0*c0 + Crs1*(4k-c0))
        mm1 = _mm_madd_pi16(mm1, mc0); //mm1 (Cbd0*c0 + Cbs0*(4k-c0), Yd0*c0 + Ys0*(4k-c0))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:0
        *(p_m64r)dst = _mm_packs_pi32(mm1, mm0);
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Cbd2, Cbs2, Yd2, Ys2)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Crd1, Crs1, Cbd1, Cbs1)
        
        mc0 = _mm_unpacklo_pi32(mc2, mc2); //mc0 (c2,4k-c2,c2,4k-c2)
        mc1 = _mm_unpackhi_pi32(mc1, mc1); //mc1 (c1,4k-c1,c1,4k-c1)
        
        //load:2
        md0 = *((p_m64r)dst + 2); //md0 (Crd3, Cbd3, Yd3, Crd2)
        ms0 = *((p_m64c)src + 2); //ms0 (Crs3, Cbs3, Ys3, Crs2)
        
        mm0 = _mm_madd_pi16(mm0, mc0); //mm0 (Cbd2*c2 + Cbs2*(4k-c2), Yd2*c2 + Ys2*(4k-c2))
        mm1 = _mm_madd_pi16(mm1, mc1); //mm1 (Crd1*c1 + Crs1*(4k-c1), Cbd1*c1 + Cbs1*(4k-c1))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:1
        *((p_m64r)dst + 1) = _mm_packs_pi32(mm1, mm0);
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Crd3, Crs3, Cbd3, Cbs3)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Yd3, Ys3, Crd2, Crs2)
        
        mc1 = _mm_unpackhi_pi32(mc2, mc2); //mc1 (c3,4k-c3,c3,4k-c3)

        //ǂ
        mc0 = _mm_min_pi16(*(p_m64c)mv0, *(p_m64c)mv1);
        
        mm0 = _mm_madd_pi16(mm0, mc1); //mm0 (Crd3*c3 + Crs3*(4k-c3), Cbd3*c3 + Cbs3*(4k-c3))
        mm1 = _mm_madd_pi16(mm1, mc2); //mm1 (Yd3*c3 + Ys3*(4k-c3), Crd2*c2 + Crs2*(4k-c2))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:2
        *((p_m64r)dst + 2) = _mm_packs_pi32(mm1, mm0);
        
        mv0 += 4;
        mv1 += 4;
        dst += 4;
        src += 4;
    }
}

//̗ʂɂăuh SSE
// 2̌oʂ̂傫ق𗘗p
NOA void blend_image_max_sse(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                             const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m64 mm0,mm1,md0,ms0,mc0,mc1,mc2;
    
    mc0 = _mm_max_pi16(*(p_m64c)mv0, *(p_m64c)mv1);
    mv0 += 4;
    mv1 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        mc1 = _mm_subs_pu16(mc_4k.m, mc0); //mc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        //load:0
        md0 = *(p_m64r)dst; //md0 (Yd1, Crd0, Cbd0, Yd0)
        ms0 = *(p_m64c)src; //ms0 (Ys1, Crs0, Cbs0, Ys0)
        
        mc2 = _mm_unpackhi_pi16(mc1, mc0); //mc2 (c3,4k-c3,c2,4k-c2)
        mc1 = _mm_unpacklo_pi16(mc1, mc0); //mc1 (c1,4k-c1,c0,4k-c0)
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Yd1,   Ys1, Crd0, Crs0)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Cbd0, Cbs0,  Yd0,  Ys0)
        
        mc0 = _mm_unpacklo_pi32(mc1, mc1); //mc0 (c0,4k-c0,c0,4k-c0)
        
        //load:1
        md0 = *((p_m64r)dst + 1); //md0 (Cbd2, Yd2, Crd1, Cbd1)
        ms0 = *((p_m64c)src + 1); //ms0 (Cbs2, Ys2, Crs1, Cbs1)
        
        mm0 = _mm_madd_pi16(mm0, mc1); //mm0 (Yd1*c1 + Ys1*(4k-c1), Crd0*c0 + Crs1*(4k-c0))
        mm1 = _mm_madd_pi16(mm1, mc0); //mm1 (Cbd0*c0 + Cbs0*(4k-c0), Yd0*c0 + Ys0*(4k-c0))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:0
        *(p_m64r)dst = _mm_packs_pi32(mm1, mm0);
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Cbd2, Cbs2, Yd2, Ys2)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Crd1, Crs1, Cbd1, Cbs1)
        
        mc0 = _mm_unpacklo_pi32(mc2, mc2); //mc0 (c2,4k-c2,c2,4k-c2)
        mc1 = _mm_unpackhi_pi32(mc1, mc1); //mc1 (c1,4k-c1,c1,4k-c1)
        
        //load:2
        md0 = *((p_m64r)dst + 2); //md0 (Crd3, Cbd3, Yd3, Crd2)
        ms0 = *((p_m64c)src + 2); //ms0 (Crs3, Cbs3, Ys3, Crs2)
        
        mm0 = _mm_madd_pi16(mm0, mc0); //mm0 (Cbd2*c2 + Cbs2*(4k-c2), Yd2*c2 + Ys2*(4k-c2))
        mm1 = _mm_madd_pi16(mm1, mc1); //mm1 (Crd1*c1 + Crs1*(4k-c1), Cbd1*c1 + Cbs1*(4k-c1))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:1
        *((p_m64r)dst + 1) = _mm_packs_pi32(mm1, mm0);
        
        mm0 = _mm_unpackhi_pi16(ms0, md0); //mm0 (Crd3, Crs3, Cbd3, Cbs3)
        mm1 = _mm_unpacklo_pi16(ms0, md0); //mm1 (Yd3, Ys3, Crd2, Crs2)
        
        mc1 = _mm_unpackhi_pi32(mc2, mc2); //mc1 (c3,4k-c3,c3,4k-c3)

        //ǂ
        mc0 = _mm_max_pi16(*(p_m64c)mv0, *(p_m64c)mv1);
        
        mm0 = _mm_madd_pi16(mm0, mc1); //mm0 (Crd3*c3 + Crs3*(4k-c3), Cbd3*c3 + Cbs3*(4k-c3))
        mm1 = _mm_madd_pi16(mm1, mc2); //mm1 (Yd3*c3 + Ys3*(4k-c3), Crd2*c2 + Crs2*(4k-c2))
        
        mm0 = _mm_add_pi32(mm0, mc_2k.m);
        mm1 = _mm_add_pi32(mm1, mc_2k.m);
        
        mm0 = _mm_srai_pi32(mm0, 12);
        mm1 = _mm_srai_pi32(mm1, 12);
        
        //store:2
        *((p_m64r)dst + 2) = _mm_packs_pi32(mm1, mm0);
        
        mv0 += 4;
        mv1 += 4;
        dst += 4;
        src += 4;
    }
}


//̗ʂɂăuh SSE2
// mv0o mv1͗pȂ
NOA void blend_image_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                          const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m128i xm0,xm1,xd0,xs0,xc0,xc1,xc2;
    
    xc0 = _mm_loadl_epi64((p_m128c)mv0);
    mv0 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        xc0 = _mm_unpacklo_epi16(xc0, _mm_setzero_si128()); //xc0 (c3,c2,c1,c0)
        xc1 = _mm_sub_epi32(xc_4k.x, xc0); //xc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        xc0 = _mm_slli_epi32(xc0, 16);
        xc0 = _mm_or_si128(xc0, xc1); //xc0 (c3,4k-c3,c2,4k-c2,c1,4k-c1,c0,4k-c0)

        xc2 = _mm_shuffle_epi32(xc0, 0xFE); //3,3,3,2:11111110
        xc1 = _mm_shuffle_epi32(xc0, 0xA5); //2,2,1,1:10100101
        xc0 = _mm_shuffle_epi32(xc0, 0x40); //1,0,0,0:01000000
        
        //load:0,1
        xd0 = _mm_loadu_si128((p_m128r)dst); //xd0 (Cbd2, Yd2, Crd1, Cbd1, Yd1, Crd0, Cbd0, Yd0)
        xs0 = _mm_loadu_si128((p_m128c)src); //xs0 (Cbs2, Ys2, Crs1, Cbs1, Ys1, Crs0, Cbs0, Ys0)
                
        xm0 = _mm_unpackhi_epi16(xs0, xd0); //xm0 (Cbd2, Cbs2,  Yd2,  Ys2, Crd1, Crs1, Cbd1, Cbs1)
        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 ( Yd1,  Ys1, Crd0, Crs0, Cbd0, Cbs0,  Yd0,  Ys0)
        
        //load:2
        xd0 = _mm_loadl_epi64((p_m128r)dst + 1); //xd0 (0,, Crd3, Cbd3, Yd3, Crd2)
        xs0 = _mm_loadl_epi64((p_m128c)src + 1); //xs0 (0,, Crs3, Cbs3, Ys3, Crs2)
        
        xm0 = _mm_madd_epi16(xm0, xc1); //xm0 (Cb2,  Y2, Cr1, Cb1)
        xm1 = _mm_madd_epi16(xm1, xc0); //xm1 ( Y1, Cr0, Cb0,  Y0)
        
        xc0 = _mm_loadl_epi64((p_m128c)mv0); //ǂ
        
        xm0 = _mm_add_epi32(xm0, xc_2k.x);
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        
        xm0 = _mm_srai_epi32(xm0, 12);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:0,1
        _mm_storeu_si128((p_m128r)dst, _mm_packs_epi32(xm1, xm0));

        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 (Crd3, Crs3, Cbd3, Cbs3, Yd3, Ys3, Crd2, Crs2)
        xm1 = _mm_madd_epi16(xm1, xc2); //mm1 (Cr3, Cb3, Y3, Cr2)
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:2
        _mm_storel_epi64((p_m128r)dst + 1, _mm_packs_epi32(xm1, xm1));
        
        mv0 += 4;
        dst += 4;
        src += 4;
    }
}

//̗ʂɂăuh SSE2
// 2̌oʂ̂ق𗘗p
NOA void blend_image_min_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                              const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m128i xm0,xm1,xd0,xs0,xc0,xc1,xc2;
    
    xc0 = _mm_loadl_epi64((p_m128c)mv0);
    xc1 = _mm_loadl_epi64((p_m128c)mv1);
    xc0 = _mm_min_epi16(xc0, xc1);
    mv0 += 4;
    mv1 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        xc0 = _mm_unpacklo_epi16(xc0, _mm_setzero_si128()); //xc0 (c3,c2,c1,c0)
        xc1 = _mm_sub_epi32(xc_4k.x, xc0); //xc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        xc0 = _mm_slli_epi32(xc0, 16);
        xc0 = _mm_or_si128(xc0, xc1); //xc0 (c3,4k-c3,c2,4k-c2,c1,4k-c1,c0,4k-c0)

        xc2 = _mm_shuffle_epi32(xc0, 0xFE); //3,3,3,2:11111110
        xc1 = _mm_shuffle_epi32(xc0, 0xA5); //2,2,1,1:10100101
        xc0 = _mm_shuffle_epi32(xc0, 0x40); //1,0,0,0:01000000
        
        //load:0,1
        xd0 = _mm_loadu_si128((p_m128r)dst); //xd0 (Cbd2, Yd2, Crd1, Cbd1, Yd1, Crd0, Cbd0, Yd0)
        xs0 = _mm_loadu_si128((p_m128c)src); //xs0 (Cbs2, Ys2, Crs1, Cbs1, Ys1, Crs0, Cbs0, Ys0)
                
        xm0 = _mm_unpackhi_epi16(xs0, xd0); //xm0 (Cbd2, Cbs2,  Yd2,  Ys2, Crd1, Crs1, Cbd1, Cbs1)
        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 ( Yd1,  Ys1, Crd0, Crs0, Cbd0, Cbs0,  Yd0,  Ys0)
        
        //load:2
        xd0 = _mm_loadl_epi64((p_m128r)dst + 1); //xd0 (0,, Crd3, Cbd3, Yd3, Crd2)
        xs0 = _mm_loadl_epi64((p_m128c)src + 1); //xs0 (0,, Crs3, Cbs3, Ys3, Crs2)
        
        xm0 = _mm_madd_epi16(xm0, xc1); //xm0 (Cb2,  Y2, Cr1, Cb1)
        xm1 = _mm_madd_epi16(xm1, xc0); //xm1 ( Y1, Cr0, Cb0,  Y0)
        
        //ǂ
        xc0 = _mm_loadl_epi64((p_m128c)mv0);
        xc1 = _mm_loadl_epi64((p_m128c)mv1);
        xc0 = _mm_min_epi16(xc0, xc1);
        
        xm0 = _mm_add_epi32(xm0, xc_2k.x);
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        
        xm0 = _mm_srai_epi32(xm0, 12);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:0,1
        _mm_storeu_si128((p_m128r)dst, _mm_packs_epi32(xm1, xm0));

        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 (Crd3, Crs3, Cbd3, Cbs3, Yd3, Ys3, Crd2, Crs2)
        xm1 = _mm_madd_epi16(xm1, xc2); //mm1 (Cr3, Cb3, Y3, Cr2)
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:2
        _mm_storel_epi64((p_m128r)dst + 1, _mm_packs_epi32(xm1, xm1));
        
        mv0 += 4;
        mv1 += 4;
        dst += 4;
        src += 4;
    }
}

//̗ʂɂăuh SSE2
// 2̌oʂ̂傫ق𗘗p
NOA void blend_image_max_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                              const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m128i xm0,xm1,xd0,xs0,xc0,xc1,xc2;
    
    xc0 = _mm_loadl_epi64((p_m128c)mv0);
    xc1 = _mm_loadl_epi64((p_m128c)mv1);
    xc0 = _mm_max_epi16(xc0, xc1);
    mv0 += 4;
    mv1 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        xc0 = _mm_unpacklo_epi16(xc0, _mm_setzero_si128()); //xc0 (c3,c2,c1,c0)
        xc1 = _mm_sub_epi32(xc_4k.x, xc0); //xc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        xc0 = _mm_slli_epi32(xc0, 16);
        xc0 = _mm_or_si128(xc0, xc1); //xc0 (c3,4k-c3,c2,4k-c2,c1,4k-c1,c0,4k-c0)

        xc2 = _mm_shuffle_epi32(xc0, 0xFE); //3,3,3,2:11111110
        xc1 = _mm_shuffle_epi32(xc0, 0xA5); //2,2,1,1:10100101
        xc0 = _mm_shuffle_epi32(xc0, 0x40); //1,0,0,0:01000000
        
        //load:0,1
        xd0 = _mm_loadu_si128((p_m128r)dst); //xd0 (Cbd2, Yd2, Crd1, Cbd1, Yd1, Crd0, Cbd0, Yd0)
        xs0 = _mm_loadu_si128((p_m128c)src); //xs0 (Cbs2, Ys2, Crs1, Cbs1, Ys1, Crs0, Cbs0, Ys0)
                
        xm0 = _mm_unpackhi_epi16(xs0, xd0); //xm0 (Cbd2, Cbs2,  Yd2,  Ys2, Crd1, Crs1, Cbd1, Cbs1)
        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 ( Yd1,  Ys1, Crd0, Crs0, Cbd0, Cbs0,  Yd0,  Ys0)
        
        //load:2
        xd0 = _mm_loadl_epi64((p_m128r)dst + 1); //xd0 (0,, Crd3, Cbd3, Yd3, Crd2)
        xs0 = _mm_loadl_epi64((p_m128c)src + 1); //xs0 (0,, Crs3, Cbs3, Ys3, Crs2)
        
        xm0 = _mm_madd_epi16(xm0, xc1); //xm0 (Cb2,  Y2, Cr1, Cb1)
        xm1 = _mm_madd_epi16(xm1, xc0); //xm1 ( Y1, Cr0, Cb0,  Y0)
        
        //ǂ
        xc0 = _mm_loadl_epi64((p_m128c)mv0);
        xc1 = _mm_loadl_epi64((p_m128c)mv1);
        xc0 = _mm_max_epi16(xc0, xc1);
        
        xm0 = _mm_add_epi32(xm0, xc_2k.x);
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        
        xm0 = _mm_srai_epi32(xm0, 12);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:0,1
        _mm_storeu_si128((p_m128r)dst, _mm_packs_epi32(xm1, xm0));

        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 (Crd3, Crs3, Cbd3, Cbs3, Yd3, Ys3, Crd2, Crs2)
        xm1 = _mm_madd_epi16(xm1, xc2); //mm1 (Cr3, Cb3, Y3, Cr2)
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:2
        _mm_storel_epi64((p_m128r)dst + 1, _mm_packs_epi32(xm1, xm1));
        
        mv0 += 4;
        mv1 += 4;
        dst += 4;
        src += 4;
    }
}

const BLEND_IMG blend_16[] =
    { blend_image, blend_image_min, blend_image_max, NULL };
const BLEND_IMG blend_sse[] =
    { blend_image_sse, blend_image_min_sse, blend_image_max_sse, NULL };
const BLEND_IMG blend_sse2[] =
    { blend_image_sse2, blend_image_min_sse2, blend_image_max_sse2, NULL };

//\
NOA void disp_motion(PIXEL_YC * restrict dst,
                     const short * restrict mv0, const short * restrict mv1,
                     int mode, int h, int w, int s)
{
    int i,j,k=1;
    int m0,m1;
    const int wc[4][2] =
        { { -2231, 3435 }, { 3435, 2231 }, { -3435, 2231 }, { -3435, -2231 } };
    
    if(mode == 0){
        // Ot[̂
        for(i=0; i<h; ++i){
            for(j=0; j<w; ++j){
                m0 = *(mv0 + j);
                
                (dst + j)->cb = (short)((m0 * wc[k][0]) >> 13);
                (dst + j)->cr = (short)((m0 * wc[k][1]) >> 13);
            }
            dst += s;
            mv0 += s;
        }
    }else if(mode == 2){
        //Ot[ ől
        for(i=0; i<h; ++i){
            for(j=0; j<w; ++j){
                m0 = *(mv0 + j);
                m1 = *(mv1 + j);
                m0 = m0 > m1 ? m0 : m1;
                
                (dst + j)->cb = (short)((m0 * wc[k][0]) >> 13);
                (dst + j)->cr = (short)((m0 * wc[k][1]) >> 13);
            }
            dst += s;
            mv0 += s;
            mv1 += s;
        }
    }else if(mode == 1){
        //Ot[ ŏl
        for(i=0; i<h; ++i){
            for(j=0; j<w; ++j){
                m0 = *(mv0 + j);
                m1 = *(mv1 + j);
                m0 = m0 < m1 ? m0 : m1;
                
                (dst + j)->cb = (short)((m0 * wc[k][0]) >> 13);
                (dst + j)->cr = (short)((m0 * wc[k][1]) >> 13);
            }
            dst += s;
            mv0 += s;
            mv1 += s;
        }
    }
}

