//-----------------------------------------------------------------------------
// mt_proc. : MT֐
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>

#include "filter.h"
#include "vflt.h"
#include "abs.h"
#include "mov.h"
#include "blend.h"
#include "mt_proc.h"

//------------------------------------------------------------------------
// LPF(MT)
//------------------------------------------------------------------------
void mt_proc_lpf(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *src,*dst;
    int i,h;
    
    h = mp.btm - mp.top;
    
    if(num > 1){
        //8sNZ̔{ŏcɕ
        int ofs,ww;
        int n = 8 * num;
        int q = mp.w / n;
        int r = mp.w % n;

        //ϓɊt
        if(id >= r){
            ofs = (q * id + r) * 8;
            ww  = (q * id + r + q) * 8;
        }else{
            ofs = (q * id + id) * 8;
            ww  = (q * id + id + q + 1) * 8;
        }

        //Nbv
        ww = ww > mp.w ? (mp.w - ofs) : (ww - ofs);
        
        //[
        src = mp.edit + ofs;
        dst = mp.temp + ofs;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_16[mp.fn](dst, src, h, ww, mp.s);
        
        //[
        src = mp.edit + ofs + mp.s * mp.btm;
        dst = mp.temp + ofs + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }else{
        //[
        src = mp.edit;
        dst = mp.temp;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_16[mp.fn](dst, src, h, mp.w, mp.s);
        
        //[
        src = mp.edit + mp.s * mp.btm;
        dst = mp.temp + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// t[ԍ(MT)
//------------------------------------------------------------------------
void mt_proc_abs(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *ref,*now;
    short *mvc;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //ŵ͈͓
    now = mp.edit + mp.s * mp.top;
    ref = mp.temp + mp.s * mp.top;
    mvc = gmc.temp;
    
    if(num > 1){
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            abs_diff(ref + c, now + c, mvc + c, mp.w);

            //[Ɖ[͌ʂRs[
            if(i == 0){
                CopyMemory(mvc - mp.s, mvc, sizeof(*mvc) * mp.w);
            }else if(i == h-1){
                CopyMemory(mvc + c + 1, mvc + c, sizeof(*mvc) * mp.w);
            }
        }
    }else{
        for(i=0; i<h; ++i){
            abs_diff(ref, now, mvc, mp.w);
            ref += mp.s;
            now += mp.s;
            mvc += mp.s;
        }
        
        //[Ɖ[͌ʂRs[
        CopyMemory(mvc, mvc - mp.s, sizeof(*mvc) * mp.w);
        CopyMemory(gmc.temp - mp.s, gmc.temp, sizeof(*mvc) * mp.w);
    }
}

//------------------------------------------------------------------------
// }XN쐬(MT)
//------------------------------------------------------------------------
void mt_proc_mov(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    mov_dtc *pm = (mov_dtc*)para2;
    short *dst,*src;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //}XNɂ̓ItZbglȂ
    dst = pm->mask;
    src = gmc.temp;
    
    _mm_empty();

    if(mp.th > 0){
        if(num > 1){
            while((i = _InterlockedExchangeAdd(&gcnt[1], 1)) < h){
                c = i * mp.s;
                detect_motion2(dst + c, src + c, mp.w, mp.s, mp.th, (float*)&grth);
            }
        }else{
            for(i=0; i<h; ++i){
                detect_motion2(dst, src, mp.w, mp.s, mp.th, (float*)&grth);
                dst += mp.s;
                src += mp.s;
            }
        }
    }else{
        if(num > 1){
            while((i = _InterlockedExchangeAdd(&gcnt[1], 1)) < h){
                c = i * mp.s;
                detect_motion(dst + c, src + c, mp.w, mp.s, mp.th, (float*)&grth);
            }
        }else{
            for(i=0; i<h; ++i){
                detect_motion(dst, src, mp.w, mp.s, mp.th, (float*)&grth);
                dst += mp.s;
                src += mp.s;
            }
        }
    }
}

//------------------------------------------------------------------------
// ̃f[^LPF̃f[^uh(MT)
//------------------------------------------------------------------------
void mt_proc_blend(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    mov_dtc **ppm = (mov_dtc**)para2;
    PIXEL_YC *src,*dst;
    short *mv0,*mv1;
    LONG i,c;
    const LONG h = mp.btm - mp.top;

    dst = mp.temp + mp.s * mp.top;
    src = mp.edit + mp.s * mp.top;
    mv0 = ppm[0]->mask;
    mv1 = ppm[1]->mask;
    
    if(mp.fn == 0){ //Õt[̂
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }else if(mp.fn == 2){ //ől
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_max(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }else if(mp.fn == 1){ //ŏl
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_min(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }
    
    _mm_empty();
}


//------------------------------------------------------------------------
// LPF MMX (MT)
//------------------------------------------------------------------------
void mt_proc_lpf_mmx(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *src,*dst;
    int i,h;
    
    h = mp.btm - mp.top;
    
    if(num > 1){
        //8sNZ̔{ŏcɕ
        int ofs,ww;
        int n = 8 * num;
        int q = mp.w / n;
        int r = mp.w % n;

        //ϓɊt
        if(id >= r){
            ofs = (q * id + r) * 8;
            ww  = (q * id + r + q) * 8;
        }else{
            ofs = (q * id + id) * 8;
            ww  = (q * id + id + q + 1) * 8;
        }

        //Nbv
        ww = ww > mp.w ? (mp.w - ofs) : (ww - ofs);
        
        //[
        src = mp.edit + ofs;
        dst = mp.temp + ofs;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_mmx[mp.fn](dst, src, h, ww, mp.s);
        
        //[
        src = mp.edit + ofs + mp.s * mp.btm;
        dst = mp.temp + ofs + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }else{
        //[
        src = mp.edit;
        dst = mp.temp;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_mmx[mp.fn](dst, src, h, mp.w, mp.s);
        
        //[
        src = mp.edit + mp.s * mp.btm;
        dst = mp.temp + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// t[ԍ SSE (MT)
//------------------------------------------------------------------------
void mt_proc_abs_sse(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *ref,*now;
    short *mvc;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //ŵ͈͓
    now = mp.edit + mp.s * mp.top;
    ref = mp.temp + mp.s * mp.top;
    mvc = gmc.temp;
    
    if(num > 1){
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            abs_diff_sse(ref + c, now + c, mvc + c, mp.w);

            //[Ɖ[͌ʂRs[
            if(i == 0){
                CopyMemory(mvc - mp.s, mvc, sizeof(*mvc) * mp.w);
            }else if(i == h-1){
                CopyMemory(mvc + c + 1, mvc + c, sizeof(*mvc) * mp.w);
            }
        }
    }else{
        for(i=0; i<h; ++i){
            abs_diff_sse(ref, now, mvc, mp.w);
            ref += mp.s;
            now += mp.s;
            mvc += mp.s;
        }
        
        //[Ɖ[͌ʂRs[
        CopyMemory(mvc, mvc - mp.s, sizeof(*mvc) * mp.w);
        CopyMemory(gmc.temp - mp.s, gmc.temp, sizeof(*mvc) * mp.w);
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// }XN쐬 SSE (MT)
//------------------------------------------------------------------------
void mt_proc_mov_sse(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    mov_dtc *pm = (mov_dtc*)para2;
    short *dst,*src;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //}XNɂ̓ItZbglȂ
    dst = pm->mask;
    src = gmc.temp;
    
    _mm_empty();

    if(mp.th > 0){
        if(num > 1){
            while((i = _InterlockedExchangeAdd(&gcnt[1], 1)) < h){
                c = i * mp.s;
                detect_motion2_sse(dst + c, src + c, mp.w, mp.s, mp.th, (float*)&grth);
            }
        }else{
            for(i=0; i<h; ++i){
                detect_motion2_sse(dst, src, mp.w, mp.s, mp.th, (float*)&grth);
                dst += mp.s;
                src += mp.s;
            }
        }
    }else{
        if(num > 1){
            while((i = _InterlockedExchangeAdd(&gcnt[1], 1)) < h){
                c = i * mp.s;
                detect_motion_sse(dst + c, src + c, mp.w, mp.s, mp.th, (float*)&grth);
            }
        }else{
            for(i=0; i<h; ++i){
                detect_motion_sse(dst, src, mp.w, mp.s, mp.th, (float*)&grth);
                dst += mp.s;
                src += mp.s;
            }
        }
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// ̃f[^LPF̃f[^uh SSE (MT)
//------------------------------------------------------------------------
void mt_proc_blend_sse(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    mov_dtc **ppm = (mov_dtc**)para2;
    PIXEL_YC *src,*dst;
    short *mv0,*mv1;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    dst = mp.temp + mp.s * mp.top;
    src = mp.edit + mp.s * mp.top;
    mv0 = ppm[0]->mask;
    mv1 = ppm[1]->mask;
    
    if(mp.fn == 0){ //Õt[̂
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_sse(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }else if(mp.fn == 2){ //ől
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_max_sse(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }else if(mp.fn == 1){ //ŏl
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_min_sse(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// LPF SSE2 (MT)
//------------------------------------------------------------------------
void mt_proc_lpf_sse2(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *src,*dst;
    int i,h;
    
    h = mp.btm - mp.top;
    
    if(num > 1){
        //8sNZ̔{ŏcɕ
        int ofs,ww;
        int n = 8 * num;
        int q = mp.w / n;
        int r = mp.w % n;

        //ϓɊt
        if(id >= r){
            ofs = (q * id + r) * 8;
            ww  = (q * id + r + q) * 8;
        }else{
            ofs = (q * id + id) * 8;
            ww  = (q * id + id + q + 1) * 8;
        }

        //Nbv
        ww = ww > mp.w ? (mp.w - ofs) : (ww - ofs);
        
        //[
        src = mp.edit + ofs;
        dst = mp.temp + ofs;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_sse2[mp.fn](dst, src, h, ww, mp.s);
        
        //[
        src = mp.edit + ofs + mp.s * mp.btm;
        dst = mp.temp + ofs + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }else{
        //[
        src = mp.edit;
        dst = mp.temp;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_sse2[mp.fn](dst, src, h, mp.w, mp.s);
        
        //[
        src = mp.edit + mp.s * mp.btm;
        dst = mp.temp + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// LPF SSE2u (MT)
//------------------------------------------------------------------------
void mt_proc_lpf_sse2u(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *src,*dst;
    int i,h;
    
    h = mp.btm - mp.top;
    
    if(num > 1){
        //8sNZ̔{ŏcɕ
        int ofs,ww;
        int n = 8 * num;
        int q = mp.w / n;
        int r = mp.w % n;

        //ϓɊt
        if(id >= r){
            ofs = (q * id + r) * 8;
            ww  = (q * id + r + q) * 8;
        }else{
            ofs = (q * id + id) * 8;
            ww  = (q * id + id + q + 1) * 8;
        }

        //Nbv
        ww = ww > mp.w ? (mp.w - ofs) : (ww - ofs);
        
        //[
        src = mp.edit + ofs;
        dst = mp.temp + ofs;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_sse2u[mp.fn](dst, src, h, ww, mp.s);
        
        //[
        src = mp.edit + ofs + mp.s * mp.btm;
        dst = mp.temp + ofs + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, ww * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }else{
        //[
        src = mp.edit;
        dst = mp.temp;
        for(i=0; i<mp.top; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
        
        //^
        vflt_sse2u[mp.fn](dst, src, h, mp.w, mp.s);
        
        //[
        src = mp.edit + mp.s * mp.btm;
        dst = mp.temp + mp.s * mp.btm;
        for(i=mp.btm ; i<mp.h; ++i){
            CopyMemory(dst, src, mp.w * sizeof(PIXEL_YC));
            dst += mp.s;
            src += mp.s;
        }
    }
    
    _mm_empty();
}

//------------------------------------------------------------------------
// t[ԍ SSE2 (MT)
//------------------------------------------------------------------------
void mt_proc_abs_sse2(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *ref,*now;
    short *mvc;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //ŵ͈͓
    now = mp.edit + mp.s * mp.top;
    ref = mp.temp + mp.s * mp.top;
    mvc = gmc.temp;
    
    if(num > 1){
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            abs_diff_sse2(ref + c, now + c, mvc + c, mp.w);

            //[Ɖ[͌ʂRs[
            if(i == 0){
                CopyMemory(mvc - mp.s, mvc, sizeof(*mvc) * mp.w);
            }else if(i == h-1){
                CopyMemory(mvc + c + 1, mvc + c, sizeof(*mvc) * mp.w);
            }
        }
    }else{
        for(i=0; i<h; ++i){
            abs_diff_sse2(ref, now, mvc, mp.w);
            ref += mp.s;
            now += mp.s;
            mvc += mp.s;
        }
        
        //[Ɖ[͌ʂRs[
        CopyMemory(mvc, mvc - mp.s, sizeof(*mvc) * mp.w);
        CopyMemory(gmc.temp - mp.s, gmc.temp, sizeof(*mvc) * mp.w);
    }
}

//------------------------------------------------------------------------
// t[ԍ SSE2u (MT)
//------------------------------------------------------------------------
void mt_proc_abs_sse2u(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    PIXEL_YC *ref,*now;
    short *mvc;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //ŵ͈͓
    now = mp.edit + mp.s * mp.top;
    ref = mp.temp + mp.s * mp.top;
    mvc = gmc.temp;
    
    if(num > 1){
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            abs_diff_sse2u(ref + c, now + c, mvc + c, mp.w);

            //[Ɖ[͌ʂRs[
            if(i == 0){
                CopyMemory(mvc - mp.s, mvc, sizeof(*mvc) * mp.w);
            }else if(i == h-1){
                CopyMemory(mvc + c + 1, mvc + c, sizeof(*mvc) * mp.w);
            }
        }
    }else{
        for(i=0; i<h; ++i){
            abs_diff_sse2u(ref, now, mvc, mp.w);
            ref += mp.s;
            now += mp.s;
            mvc += mp.s;
        }
        
        //[Ɖ[͌ʂRs[
        CopyMemory(mvc, mvc - mp.s, sizeof(*mvc) * mp.w);
        CopyMemory(gmc.temp - mp.s, gmc.temp, sizeof(*mvc) * mp.w);
    }
}

//------------------------------------------------------------------------
// }XN쐬 SSE2 (MT)
//------------------------------------------------------------------------
void mt_proc_mov_sse2(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    mov_dtc *pm = (mov_dtc*)para2;
    short *dst,*src;
    LONG i,c;
    const LONG h = mp.btm - mp.top;
    
    //}XNɂ̓ItZbglȂ
    dst = pm->mask;
    src = gmc.temp;
    
    _mm_empty();

    if(mp.th > 0){
        if(num > 1){
            while((i = _InterlockedExchangeAdd(&gcnt[1], 1)) < h){
                c = i * mp.s;
                detect_motion2_sse2(dst + c, src + c, mp.w, mp.s, mp.th, (float*)&grth);
            }
        }else{
            for(i=0; i<h; ++i){
                detect_motion2_sse2(dst, src, mp.w, mp.s, mp.th, (float*)&grth);
                dst += mp.s;
                src += mp.s;
            }
        }
    }else{
        if(num > 1){
            while((i = _InterlockedExchangeAdd(&gcnt[1], 1)) < h){
                c = i * mp.s;
                detect_motion_sse2(dst + c, src + c, mp.w, mp.s, mp.th, (float*)&grth);
            }
        }else{
            for(i=0; i<h; ++i){
                detect_motion_sse2(dst, src, mp.w, mp.s, mp.th, (float*)&grth);
                dst += mp.s;
                src += mp.s;
            }
        }
    }
}

//------------------------------------------------------------------------
// ̃f[^LPF̃f[^uh SSE2 (MT)
//------------------------------------------------------------------------
void mt_proc_blend_sse2(int id, int num, void *para1, void *para2)
{
    mt_param mp = *(mt_param *)para1;
    mov_dtc **ppm = (mov_dtc**)para2;
    PIXEL_YC *src,*dst;
    short *mv0,*mv1;
    LONG i,c;
    const LONG h = mp.btm - mp.top;

    dst = mp.temp + mp.s * mp.top;
    src = mp.edit + mp.s * mp.top;
    mv0 = ppm[0]->mask;
    mv1 = ppm[1]->mask;
    
    if(mp.fn == 0){ //Õt[̂
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_sse2(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }else if(mp.fn == 2){ //ől
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_max_sse2(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }else if(mp.fn == 1){ //ŏl
        while((i = _InterlockedExchangeAdd(gcnt, 1)) < h){
            c = i * mp.s;
            blend_image_min_sse2(dst + c, src + c, mv0 + c, mv1 + c, mp.w);
        }
    }
    
    _mm_empty();
}

